package com.ashokit.transactionmgmt;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import com.ashokit.transactionmgmt.model.Employee;
import com.ashokit.transactionmgmt.model.Insurance;
import com.ashokit.transactionmgmt.service.OrganizationService;

@SpringBootApplication
public class TransactionMgmtApplication implements CommandLineRunner {
	
	@Autowired
	private OrganizationService orgService;

	public static void main(String[] args) {
		SpringApplication.run(TransactionMgmtApplication.class, args);
	}

	@Override
	public void run(String... args) throws Exception {
		
		
		Employee emp = new Employee();
		emp.setEmpName("Sagar");

		Insurance employeeHealthInsurance = new Insurance();
		employeeHealthInsurance.setHealthInsuranceSchemeName("Test");
		employeeHealthInsurance.setCoverageAmount(1000000);
		
		orgService.onBoardEmployee(emp, employeeHealthInsurance);
		
		//Employee one record NO Employee creation is sucess for Sagar
		 
		//Insurance one record NO 
		//Insurance creation is Failed   with insurance Name ===> Test  For the Employe ==>   Sagar
		
		//Audit two records 1) Employee Audit 2) Insurance Audit
		
	}

}
