package com.ashokit.transactionmgmt.service;

import javax.management.RuntimeErrorException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ashokit.transactionmgmt.model.Audit;
import com.ashokit.transactionmgmt.model.Employee;
import com.ashokit.transactionmgmt.model.Insurance;


@Service
public class OrganizationService {
	
	
	@Autowired
	private EmployeeService empService;
	
	
	@Autowired
	private InsuranceService insService;
	
	
	@Autowired
	private AuditService auditService;
	
	//This the is common service
	
	
	@Transactional(propagation = Propagation.REQUIRED)
	//REQUIRED ==> Its the default Propogation ==> Creating Transaction Object  //T1
	public void onBoardEmployee(Employee emp,Insurance ins) {
		


		Employee employee = empService.saveEmployee(emp); //T1

		if (employee.getEmpId() != null) { //If Employee Saved Successfully
			auditService.saveAudit(new Audit("Employee creation is sucess for " + employee.getEmpName()));//T2
			ins.setEmpId(employee.getEmpId());

		} else {//If Employee is not Saved Sucessfully
			auditService.saveAudit(new Audit("Employee creation is Failed for " + employee.getEmpName())); //T2
		}

		//T2 Scope will be completed
		ins.setEmpId(emp.getEmpId());
		

		if (ins.getHealthInsuranceSchemeName().length() <=5) { //If Insurance Validation Failed
			
			auditService.saveAudit(new Audit("Insurance creation is Failed for  with insurance Name ===> "
					+ ins.getHealthInsuranceSchemeName() + "  For the Employe ==>   " + employee.getEmpName())); //T3
			throw new RuntimeErrorException(null, "Error in Insurance");
		}

		else { //If insurance validation is success
			insService.registerInsurance(ins); //T1
			auditService.saveAudit(new Audit("Insurance creation is Sucess for " + employee.getEmpName()));//T3
		}
	
	}

}
